#!/usr/bin/perl
##############################################
# index.cgi - e_Board v2.0
#
# This script runs a message board on you site. 
# It was inspired by Matt Wright's WWWBoard.
# This script by Mike Bagneski - copyright 1998. 
# Do not redistribute.
# 
##################################################
# CONFIGURATION SECTION

# This is the complete path your eboard directory.

$htmlpath = '/path/to/public_html/e_chat/eboard';

# This is the URL of your eboard directory.

$htmlurl = 'http://www.yoururl.com/~user/eboard';

# This is the URL of the [Exit Board] link.

$exiturl = 'http://www.yoururl.com/~user/index.htm';

# This is your admin password.

$password = 'password';

# END OF CONFIGURATION SECTION
###################################################
# OPTIONS SECTION

# Uncomment one of the following, depending on how you want the 
# board to handle HTML.

#$html = 'no';		# if you want all HTML removed from message
$html = 'show';		# if you want to display the code as text
#$html = 'allow';		# if you're nuts.

# This is the length of each line of quoted text in the reply form.
# You only need to change this if you change your textarea dimensions.

$len = 60;

# This is the default condition of the main message page.  
# Change to 'Expand' if you want all messages displayed by default.

$init_threads = 'Collapse';

# The number of seconds that a message is marked new.
# The default is 24 hours.

$newtime = 60*60*24;

# The number of seconds until a topic expires.
# The default is 30 days.

$expiration = 60*60*24*30;

# Set to 'no' if you want expired messages to be deleted.
# Set to 'yes' to have them archived.

$x2archive = 'no';

# This is the HTML of your NEW marker.  This can be an image if you want.

$new = '<font color=red>NEW</font>';

# This is the term used in the form to denote quoted text.

$wrote = 'wrote';

# This is the path to sendmail.  It's usually the default.
# Consult your provider if it isn't.

$sendmail = '/usr/lib/sendmail';

# This is the admin's e-mail address.  The admin will receive 
# a copy of each message, incluing IP and REMOTE HOST info.

$sysadmin = 'e_chat@wipd.com';

# This is the HTMl for reply indentation.  You can substitute
# a transparent image if you want.

$indent = ' &nbsp; &nbsp; &nbsp; &nbsp; ';

# After initial testing, set this to 'yes'.
# If your server allows file locking, this will reduce errors.

	$lockon = 'no';

# This is the list of naughty words, and what you want to convert
# them to.

	%naughty = (fuck => 'hug', shit => 'pudding', pecker => 'puppy', asshole => 'angel', bitch => 'nice person', cunt => 'stopwatch', ' cock' => ' earlobe', 'cock!' => 'socks!', cocksucker => 'sweetheart', pussy => 'portable wishwasher', ' tit' => ' toe');

# These are the anmes and locations of the gifs shown with the lists.

$postimage = "$htmlurl/post.gif";
$replyimage = "$htmlurl/reply.gif";

# These are the names of the various files.  No need to change them
# unless you change the actual file names.

$list_template = 'template/listtmp.txt';
$msg_template = 'template/msgtmp.txt';
$prev_template = 'template/pretmp.txt';
$error_template = 'template/errtmp.txt';
$subscribe_template = 'template/subtmp.txt';
$form_template = 'template/formtmp.txt';
$banlist = 'banlist.txt';
$mlist = 'mlist.txt';
$alist = 'alist.txt';
$countfile = 'counter.txt';

# END OF OPTIONS SECTION
############################################
# Set to flush output

select (STDOUT);
$| = 1;

############################################
# get form data

read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
if ($ENV{'QUERY_STRING'})
	{$buffer = "$buffer\&$ENV{'QUERY_STRING'}";
}
@pairs = split(/&/,$buffer);
foreach $pair (@pairs){
	($name,$value) = split(/=/,$pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
	if (($html eq 'no') or ($name eq 'subject') or ($name =~ /url/)){
		$value =~ s/<.*?>//g;
		$value =~ s/"/&quot;/g;
	}elsif($html eq 'show'){
		$value =~ s/</&lt;/g;
		$value =~ s/>/&gt;/g;
		$value =~ s/"/&quot;/g;
	}

	# Censor Naughty Words
	for(keys(%naughty)){
		$value =~ s/$_/$naughty{$_}/gi;
	}
	$value = '' if(($name eq 'email') and ($value !~ /.*\@.*\..*/));
	$value = '' if(($name =~ /url$/) and ($value !~ /.*tp:.*\..*/));
	$FORM{$name} = $value;
}

$FORM{'threads'} = $init_threads unless $FORM{'threads'};
$FORM{'mode'} = 'Current' unless $FORM{'mode'};
$FORM{'actionurl'} = $ENV{'SCRIPT_NAME'};

if($FORM{'mode'} eq 'Current') {
	open(LIST, "$htmlpath/$mlist");
	flock LIST, 2 if $lockon eq 'yes';
	@list = <LIST>;
	&expire;
} else {
	open(LIST, "$htmlpath/$alist");
	flock LIST, 2 if $lockon eq 'yes';
	@list = <LIST>;
}


########################################
# check for banned status

$ip = $ENV{'REMOTE_HOST'};

open (BANLIST,"$htmlpath/$banlist");
@blist = <BANLIST>;
close (BANLIST);

foreach $bannedip (@blist) {
	chomp($bannedip);
	if ($ip =~ /$bannedip/) {
		print "Content-type: text/html\n\n";
		print "<html><head></head><body>\n";
		print "<h1 align=center>Sorry, you've been denied access to this Board.</h1>\n";
		print "</body></html>";
		exit;
	}
}


if (exists($FORM{'post'})){
	if(($FORM{'name'}) and ($FORM{'subject'}) and ($FORM{'body'})){
		&post;
		exit;
	}else{
		&error;
		exit;
	}
}

if (exists($FORM{'preview'})){
	if(($FORM{'name'}) and ($FORM{'subject'}) and ($FORM{'body'})){
		&preview;
		exit;
	}else{
		&error;
		exit;
	}
}

if (exists($FORM{'message'})){
	open(MESSAGE, "$htmlpath/messages/$FORM{'message'}.txt");
	@data = <MESSAGE>;
	close(MESSAGE);
	$message = $FORM{'message'};
	print "Content-type: text/html\n\n";
	&view;
	exit;
}

if (exists($FORM{'admin'})){
	&password;
	exit;
}

if (exists($FORM{'password'})){
	if($FORM{'password'} ne $password){
		&password;
		exit;
	}else{
		&delete;
	}
}

if (exists($FORM{'subform'})){
	open(SUBSCRIBE, "$htmlpath/$subscribe_template");
	@lines = <SUBSCRIBE>;
	close(SUBSCRIBE);
	chomp(@lines);

	print "Content-type: text/html\n\n";

	foreach $line (@lines){
		$line =~ s/\*boardurl\*/$ENV{'SCRIPT_NAME'}\?threads=$FORM{'threads'}&mode=$FORM{'mode'}/;
		$line =~ s/\*actionurl\*/$FORM{'actionurl'}/;
		print "$line\n";
	}
	exit;
}

if(exists($FORM{'subscription'})){
	if($FORM{'subaddress'} =~ /@/){
		&subscribe;
	}
}

#####################################################
# View Main Page (default)

open(TEMPLATE, "$htmlpath/$list_template");
@lines = <TEMPLATE>;
close(TEMPLATE);
chomp(@lines);

open(COUNTER, "$htmlpath/$countfile");
$counter = <COUNTER>;
close(COUNTER);

print "Content-type: text/html\n\n";

foreach $line (@lines){
	$line =~ s/\*boardurl\*/$ENV{'SCRIPT_NAME'}\?mode=$FORM{'mode'}&threads=$FORM{'threads'}/g;
	$line =~ s/\*boardurla\*/$ENV{'SCRIPT_NAME'}\?threads=\*threads\*&mode=$FORM{'mode'}/g;
	$line =~ s/\*boardurlb\*/$ENV{'SCRIPT_NAME'}\?mode=\*mode\*&threads=$FORM{'threads'}/g;
	$line =~ s/\*htmlurl\*/$htmlurl/g;
	$line =~ s/\*exiturl\*/$exiturl/g;
	if($line =~ /\*mode\*/) {
		if($FORM{'mode'} eq 'Current'){$line =~ s/\*mode\*/Archived/g};
		if($FORM{'mode'} eq 'Archived'){$line =~ s/\*mode\*/Current/g};
	}
	if($line =~ /\*threads\*/){
		if($FORM{'threads'} eq 'Collapse'){$line =~ s/\*threads\*/Expand/g};
		if($FORM{'threads'} eq 'Expand'){$line =~ s/\*threads\*/Collapse/g};
	}
	if($line =~ /\*list\*/){
		foreach $item (@list){
			@items = split(/\t/,$item);
			if(($FORM{'threads'} eq 'Collapse') and ($items[0]) and (time - $items[5] >= $newtime)){next}
			for($i=0;$i<$items[0];$i++){
				print "$indent";
			}
			if($items[0]){
				print "<img src=$replyimage align=middle alt=\"\">";
			}else{
				print "<img src=$postimage align=middle alt=\"\">";
			}
			print "<a href=\"$ENV{'SCRIPT_NAME'}?message=$items[1]&threads=$FORM{'threads'}&mode=$FORM{'mode'}\">$items[2]<\/a> - <b>$items[3]<\/b> on <i><small>$items[4]<\/small><\/i>";
			if ((time - $items[5]) < $newtime){print "$new"}
			print "<br>\n";
		}
	}elsif($line =~ /\*form\*/){
		open(TEMPLATE, "$htmlpath/$form_template");
		@form = <TEMPLATE>;
		close(TEMPLATE);
		chomp(@form);
	
		foreach $formline (@form){
			$formline =~ s/\*actionurl\*/$FORM{'actionurl'}/g;
			$formline =~ s/\*threads\*/$FORM{'threads'}/;
			if($formline =~ /\*\w+\*/){
				$formline =~ s/\*\w+\*//g;
			}
			print "$formline\n";
		}
	}else{
		print "$line\n";
	}
}


exit;

####################################################
# View a message

sub view{

	chomp(@data);

	open(TEMPLATE, "$htmlpath/$msg_template");
	@lines = <TEMPLATE>;
	close(TEMPLATE);
	chomp(@lines);

	#############################################
	# generate substitution fields
	
	@fields = ('getemail', 'subject', 'name', 'email', 'date', 'body', 'previoussubject', 'previousname', 'previousfilename', 'previousdate', 'url', 'urltitle', 'imageurl');

	for ($i=0;$i<=$#data;$i++){
		$messagefields{"$fields[$i]"} = "$data[$i]";
	}

	$messagefields{'list'} = '';
	$messagefields{'form'} = '';
	$messagefields{'previousfilenameurl'} = "$ENV{'SCRIPT_NAME'}?message=$messagefields{'previousfilename'}&threads=$FORM{'threads'}&mode=$FORM{'mode'}";
	$messagefields{'message'} = $message;
	$messagefields{'urltitle'} = $messagefields{'url'} if $messagefields{'urltitle'} eq '';
	$messagefields{'boardurl'} = "$ENV{'SCRIPT_NAME'}?threads=$FORM{'threads'}&mode=$FORM{'mode'}";
	$messagefields{'htmlurl'} = $htmlurl;

	$body = $messagefields{'body'};
	$body =~ s/\*br\*/<br>/g;
	$body =~ s/\*p\*/<p>/g;
	$messagefields{'body'} = $body;


	#############################################
	# Generate Message

	foreach $line (@lines){
		foreach $field (keys(%messagefields)){
			if($line =~ /\*$field\*/){
				if($field eq 'list'){
					&replylist;
					$line = '';
				}elsif($field eq 'form'){
					&doform;
					$line = '';
				}elsif(($messagefields{"$field"} ne '') or ($line =~ /value=/)){
					$line =~ s/\*$field\*/$messagefields{"$field"}/g;
				}elsif($field eq 'email'){
					$line =~ s/<a.+?>//i;
					$line =~ s/<\/a>//i;
				}else{
					$line = '';
				}
			}
		}
		print "$line\n";
	}
}

####### Display Message Form

sub doform{

	############## Generate Substitution Fields

	$formfields{'name'} = '';
	$formfields{'email'} = '';
	$formfields{'subject'} = '';
	$formfields{'url'} = '';
	$formfields{'urltitle'} = '';
	$formfields{'imageurl'} = '';
	$formfields{'previoussubject'} = $messagefields{'subject'};
	$formfields{'previousname'} = $messagefields{'name'};
	$formfields{'previousfilename'} = $FORM{'message'};
	$formfields{'previousdate'} = $messagefields{'date'};
	$formfields{'quotedsubject'} = ($messagefields{'subject'} =~ /Re:/) ? "$messagefields{'subject'}" : "Re: $messagefields{'subject'}";
	$formfields{'getemail'} = ($messagefields{'getemail'} !~ /@/) ? '' : "$messagefields{'getemail'}";
	$formfields{'actionurl'} = $FORM{'actionurl'};
	$formfields{'threads'} = $FORM{'threads'};
	$formfields{'mode'} = $FORM{'mode'};

	$text = $messagefields{'body'};

	###########################################
	# Quote Text

	@sections = split(/<p>/, $text);
	for($k=0;$k<=$#sections;$k++){
		@paragraphs = split(/<br>/, $sections[$k]);
		for($i=0;$i<=$#paragraphs;$i++){
			$para = $paragraphs[$i];
			if($para =~ /^:/){next};
			if (length($para) > $len){
				@sub = ();
				while(length($para) > $len){
					$j = $len;
					while((substr($para,$j,1) ne ' ') and ($j)){$j--};
					unless($j){$j = $len};
					$pretext = substr($para,0,$j+1);
					$para = substr($para,$j+1);
					push(@sub, $pretext);
				}
				push(@sub, $para);
				splice(@paragraphs, $i, 1, @sub);
				$i += $#sub;
			}
		}
		$sections[$k] = join('<br>', @paragraphs);
	}
	$text = join('<p>', @sections);

	$text = "\n" . $formfields{'previousname'} . " $wrote,<br>$text" . '<br>';

	$text =~ s/<br>/\n: /g;
	$text =~ s/<p>/\n:\n: /g;
	$text =~ s/</&lt;/g;
	$text =~ s/>/&gt;/g;
	$text =~ s/"/&quot;/g;
	$text =~ s/: $//;
	$formfields{'quotedtext'} = $text;

	##############################################
	# Print Message Form

	open(TEMPLATE, "$htmlpath/$form_template");
	@form = <TEMPLATE>;
	close(TEMPLATE);
	chomp(@form);

	foreach $formline (@form){
		if($formline =~ /getemail/){
			$formline = "<input type=hidden name=getemail value=\"$formfields{'getemail'}\">";
		}
		foreach $field (keys(%formfields)){
			if($formline =~ /\*$field\*/){
				$formline =~ s/\*$field\*/$formfields{"$field"}/g;
			}
		}
	print "$formline\n";
	}
}

######## Display Message Page Replies

sub replylist{
	for($j=0;$j<=$#list;$j++){
		@item = split(/\t/,$list[$j]);
		if($FORM{'message'} eq $item[1]){
			$j++;
			$toplevel = $item[0];
			for ($j=$j;$j<=$#list;$j++){
				@subitem = split(/\t/,$list[$j]);
				if($subitem[0] gt $toplevel){
					for($k=$toplevel;$k<$subitem[0];$k++){
						print "$indent";
					}
					print "<img src=$replyimage align=absmiddle alt=\"\"><a href=\"$messagefields{'boardurl'}&message=$subitem[1]\">$subitem[2]<\/a> - <b>$subitem[3]<\/b><i><small> on $subitem[4]<\/small><\/i><br>\n";
				}else{last};
			}
		}
	}
}

##################################################
# View Preview Message

sub preview{

	open(TEMPLATE, "$htmlpath/$prev_template");
	@lines = <TEMPLATE>;
	close(TEMPLATE);
	chomp(@lines);

	&show_rest;
}

##################################################
# View Error Message

sub error{

	open(TEMPLATE, "$htmlpath/$error_template");
	@lines = <TEMPLATE>;
	close(TEMPLATE);
	chomp(@lines);

	&show_rest;
}	

##################################################
# Display the Rest of the Page

sub show_rest{

	print "Content-type: text/html\n\n";

	############################################
	# Generate Substitution Fields

	$FORM{'date'} = localtime;
	$FORM{'body'} =~ s/\r//g;
	$FORM{'quotedtext'} = $FORM{'body'};
	$FORM{'body'} =~ s/\n\n/<p>/g;
	$FORM{'body'} =~ s/\n/<br>/g;

	$FORM{'quotedsubject'} = $FORM{'subject'};

	$FORM{'boardurl'} = "$ENV{'SCRIPT_NAME'}?threads=$FORM{'threads'}&mode=$FORM{'mode'}";
	$FORM{'previousfilenameurl'} = "$FORM{'boardurl'}&message=$FORM{'previousfilename'}";
	$FORM{'actionurl'} = $ENV{'SCRIPT_NAME'};

	$FORM{'form'} = '';

	if ($FORM{'urltitle'} eq ''){
		$FORM{'urltitle'} = $FORM{'url'};
	}

	##############################################
	# Print Preview or Error Message

	foreach $line (@lines){
		foreach $field (keys(%FORM)){
			if($line =~ /\*$field\*/){
				if(($FORM{"$field"} ne '') or ($line =~ /value=/)){
					$line =~ s/\*$field\*/$FORM{"$field"}/g;
				}elsif($field eq 'email'){
					$line =~ s/<a.+?>//;
					$line =~ s/<\/a>//;
				}elsif($field eq 'form'){
					open(TEMPLATE, "$htmlpath/$form_template");
					@form = <TEMPLATE>;
					close(TEMPLATE);
					chomp(@form);

					foreach $formline (@form){
						if($formline =~ /getemail/){
							unless ($FORM{'previousfilename'}){
								$formline =~ s/>/ CHECKED>/ if $FORM{'getemail'} eq 'yes';
							}else{
								$formline = "<input type=hidden name=getemail value=\"$FORM{'getemail'}\">";
							}
						}
						foreach $formfield (keys(%FORM)){
							if($formline =~ /\*$formfield\*/){
								$formline =~ s/\*$formfield\*/$FORM{"$formfield"}/g;
							}
						}
						print "$formline\n";
					}
					$line = '';
				}else{
					$line = '';
				}
			}
		}
	print "$line\n";
	}
}

####################################################
# Post Message

sub post{

	##############################################
	# Increment counter

	open(COUNTER, "+<$htmlpath/$countfile");
	flock COUNTER, 2 if $lockon eq 'yes';
	$counter = <COUNTER>;
	$counter ++;
	seek (COUNTER, 0, 0);
	print COUNTER "$counter";
	close(COUNTER);

	$FORM{'date'} = localtime;

	$FORM{'emailbody'} = $FORM{'body'};
	$FORM{'emailbody'} =~ s/&lt;/</g;
	$FORM{'emailbody'} =~ s/&gt;/>/g;
	$FORM{'emailbody'} =~ s/&quot;/\"/;

	$FORM{'emailsubject'} = $FORM{'subject'};
	$FORM{'emailsubject'} =~ s/&quot;/\"/;

	$FORM{'body'} =~ s/\r//g;
	$FORM{'body'} =~ s/\n\n/*p*/g;
	$FORM{'body'} =~ s/\n/*br*/g;


	$FORM{'message'} = $counter;

	if($FORM{'getemail'} eq 'yes'){
		$FORM{'getemail'} = $FORM{'email'};
	}

	#################################################
	# Write message Data to File

	open(MESSAGE, ">$htmlpath/messages/$counter.txt");
	flock MESSAGE, 2 if $lockon eq 'yes';
	print MESSAGE "$FORM{'getemail'}\n";
	print MESSAGE "$FORM{'subject'}\n";
	print MESSAGE "$FORM{'name'}\n";
	print MESSAGE "$FORM{'email'}\n";
	print MESSAGE "$FORM{'date'}\n";
	print MESSAGE "$FORM{'body'}\n";
	print MESSAGE "$FORM{'previoussubject'}\n";
	print MESSAGE "$FORM{'previousname'}\n";
	print MESSAGE "$FORM{'previousfilename'}\n";
	print MESSAGE "$FORM{'previousdate'}\n";
	print MESSAGE "$FORM{'url'}\n";
	print MESSAGE "$FORM{'urltitle'}\n";
	print MESSAGE "$FORM{'imageurl'}\n";
	close(MESSAGE);

	###########################################
	# Update Message List (mlist)

	$FORM{'name'} =~ s/<.*?>//g;
	$time = time;

	unless($FORM{'previousfilename'}){
		$newitem = "0\t$counter\t$FORM{'subject'}\t$FORM{'name'}\t$FORM{'date'}\t$time\n";
		unshift(@list,$newitem);
	}else{
		for($i=0;$i<=$#list;$i++){
			@item = split (/\t/,$list[$i]);
			if($item[1] eq $FORM{'previousfilename'}){
				$level = $item[0];
				$newlevel = $level + 1;
				$newitem = "$newlevel\t$counter\t$FORM{'subject'}\t$FORM{'name'}\t$FORM{'date'}\t$time\n";
				splice(@list, $i+1, 0, $newitem);
				last;
			}
		}
	}
	if($FORM{'mode'} eq 'Current') {
		open(LIST, ">$htmlpath/$mlist");
	}else{
		open(LIST, ">$htmlpath/$alist");
	}
	flock LIST, 2 if $lockon eq 'yes';
	seek (LIST, 0, 0);
	print LIST @list;
	close(LIST);

	open(MESSAGE, "$htmlpath/messages/$counter.txt");
	@data = <MESSAGE>;
	$message = $counter;
	print "Content-type: text/html\n\n";
	&view;

	&email;

}

#################################################
# Get password

sub password{
	print "Content-type: text/html\n\n";
	print "<html><head></head><body>\n";
	print "<center><b>Type in password and hit Enter to delete this message and all of its replies.</b>\n";
	print "<form action=\"$ENV{'SCRIPT_NAME'}\" method=POST>\n";
	print "<input type=text name=password><br>\n";
	print "<b>Archive Message?</b><br>";
	print "<b>Yes</b><input type=radio name=archive value=yes> ";
	print "<b>No</b><input type=radio name=archive value=no CHECKED>\n";
	print "<input type=hidden name=admmessage value=$FORM{'admin'}>\n";
	print "<input type=hidden name=threads value=$FORM{'threads'}>\n";
	print "<input type=hidden name=mode value=$FORM{'mode'}>\n";
	print "</form></center></body></html>\n";
}

################################################
# Delete messages

sub delete{
	$message = $FORM{'admmessage'};
	$archive = $FORM{'archive'};
	@templist = () if $archive eq 'yes';
	unlink("$htmlpath/messages/$message.txt") if $archive eq 'no';
	for($i=0;$i<=$#list;$i++){
		@items = split (/\t/, $list[$i]);
		chomp(@items);
		if($items[1] eq $message){
			$mlevel = $items[0];
			$temp = splice(@list, $i, 1);
			push(@templist, $temp) if $archive eq 'yes';
			@items = split (/\t/, $list[$i]);
			while($items[0] gt $mlevel){
				unlink("$htmlpath/messages/$items[1].txt") if $archive eq 'no';
				$temp = splice(@list, $i, 1);
				push(@templist, $temp) if $archive eq 'yes';
				@items = split (/\t/, $list[$i]);
			}
			open(MLIST, ">$htmlpath/$mlist");
			flock MLIST, 2 if $lockon eq 'yes';
			print MLIST @list;
			close(MLIST);
			last if $archive eq 'no';
			open (ALIST, "$htmlpath/$alist");
			flock ALIST, 2 if $lockon eq 'yes';
			@alist = <ALIST>;
			unshift (@alist, @templist);
			open (ALIST, ">$htmlpath/$alist");
			flock ALIST, 2 if $lockon eq 'yes';
			print ALIST @alist;
			close (ALIST);
			last;
		}
	}
}
################################################
#  Subscribe or Cancel

sub subscribe{
	open(SLIST, "$htmlpath/slist.txt");
	@subscribers = <SLIST>;
	close(SLIST);

	if ($FORM{'mode'} eq 'subscribe'){
		push(@subscribers,"$FORM{'subaddress'}\n") unless grep(/$FORM{'subaddress'}/, @subscribers);
	}else{
		for($i=0;$i<=$#subscribers;$i++){
			if($subscribers[$i] eq "$FORM{'subaddress'}\n"){
				splice(@subscribers,$i,1);
				last;
			}
		}
	}
	open(SLIST, ">$htmlpath/slist.txt");
	print SLIST @subscribers;
	close(SLIST);
}
#################################################
# Expire old topics

sub expire {
	for($i=$#list;$i>=0;$i--) {
		@items = split(/\t/, $list[$i]);
		next if $items[0] ne '0';
		last if $items[5] > time - $expiration;
		$FORM{'admmessage'} = $items[1];
		$FORM{'archive'} = $x2archive;
		&delete;
	}
}

#################################################
# Email routine

sub email {

	$script_name = $ENV{'SCRIPT_NAME'};
	$script_name =~ s#^/## ; 
	$cgiurl = "http://$ENV{'SERVER_NAME'}/$script_name";

	if($sysadmin){&send_email("$sysadmin")}

	if($FORM{'getemail'} =~ /\@/){&send_email("$FORM{'getemail'}")}

	open(SLIST, "$htmlpath/slist.txt");
	@subscribers = <SLIST>;
	close(SLIST);
	foreach $address (@subscribers){
		next if $address !~ /\@/;
		&send_email("$address");
	}
}
sub send_email {
	local($address) = @_;
	open(EMAIL, "|$sendmail $address");
	print EMAIL "From: $FORM{'name'}\n";
	print EMAIL "Subject: e_Chat Board Message - $FORM{'emailsubject'}\n";
	print EMAIL "Reply-To: $FORM{'email'}\n\n";
	print EMAIL "$FORM{'emailbody'}\n\n";
	print EMAIL "LINK IN MESSAGE = $FORM{'url'}\n" if $FORM{'url'};
	print EMAIL "MESSAGE = $cgiurl?message=$counter\n\n";
	print EMAIL "URL for remote delete = $cgiurl?admmessage=$counter&archive=no&password=$password\n" if $address eq $sysadmin;
	print EMAIL "Poster's Remote Host = $ENV{'REMOTE_HOST'}\n" if $address eq $sysadmin;
	close(EMAIL);
}